<template>
  <q-page class="fit row wrap item-start justify-start">
    <div
      v-if="Array.isArray(questions) && questions.length == 0"
      class="row items-start justify-evenly"
    >
      <q-card flat bordered class="col-4">
        <q-card-section>
          <div class="text-h6">No has creado preguntas</div>
        </q-card-section>
        <q-card-section class="q-pt-none">
          Crea una nueva pregunta para poder compartirla con otros usuarios, que podrás usar luego en tus propias pruebas. Ellos podrán sugerir correcciones o validar lo que has hecho, para que tu trabajo sea aún mejor.
        </q-card-section>
      </q-card>
    </div>
    <div
      v-for="(question, index) in questions"
      v-bind:key="index"
      class="col-md-3 q-pa-md"
    >
      <question-card
        v-bind:question="question"
        v-bind:copyable="true"
        v-on:copyQuestion="onCopyQuestion"
      />
    </div>
  </q-page>
</template>

<script>
import { mapGetters } from 'vuex'
export default {
  name: 'QuestionRevision',
  components: {
    QuestionCard: () => import('../../components/question/QuestionCard')
  },
  data () {
    return {
      questions: []
    }
  },
  computed: {
    ...mapGetters({
      userId: 'auth/getId'
    })
  },
  mounted () {
    // TODO: mejorar reactividad: muestra el "no ha creado" cuando está cargando el listado.
    this.$connection.get('api/question/byAutor', { autorId: this.userId })
      .then((response) => {
        this.questions = response.data
      })
      .catch(() => {
        this.$q.notify({
          color: 'negative',
          textColor: 'white',
          icon: 'cloud_off',
          message: 'Error al recuperar su información.'
        })
        this.$store.dispatch('auth/logOut')
        this.$router.go(-1)
      })
  },
  methods: {
    onCopyQuestion (val) {
      this.$store.dispatch('current/addNewSugestion', val)
    }
  }
}
</script>
